#!/usr/bin/env python3
import re

funcs = {b'0' : 'rgb64ToY_c_template',
    b'1' : 'rgb64ToUV_c_template',
    b'1_half' : 'rgb64ToUV_half_c_template',
    b'2' : 'rgb48ToY_c_template',
    b'3' : 'rgb48ToUV_c_template',
    b'3_half' : 'rgb48ToUV_half_c_template',
    b'4' : 'rgb16_32ToY_c_template',
    b'5' : 'rgb16_32ToUV_c_template',
    b'5_half' : 'rgb16_32ToUV_half_c_template',
    b'6' : 'gbr24pToUV_half_c',
    b'7' : 'rgba64leToA_c',
    b'8' : 'rgba64beToA_c',
    b'9' : 'abgrToA_c',
    b'10' : 'rgbaToA_c',
    b'11' : 'palToA_c',
    b'12' : 'palToY_c',
    b'13' : 'palToUV_c',
    b'14' : 'monowhite2Y_c',
    b'15' : 'monoblack2Y_c',
    b'16' : 'yuy2ToY_c',
    b'17' : 'yuy2ToUV_c',
    b'18' : 'yvy2ToUV_c',
    b'19' : 'bswap16Y_c',
    b'20' : 'bswap16UV_c',
    b'21' : 'read_ya16le_gray_c',
    b'22' : 'read_ya16le_alpha_c',
    b'23' : 'read_ya16be_gray_c',
    b'24' : 'read_ya16be_alpha_c',
    b'25' : 'read_ayuv64le_Y_c',
    b'26' : 'read_ayuv64le_UV_c',
    b'27' : 'read_ayuv64le_A_c',
    b'28' : 'uyvyToY_c',
    b'29' : 'uyvyToUV_c',
    b'30' : 'nvXXtoUV_c',
    b'31' : 'p010LEToY_c',
    b'32' : 'p010BEToY_c',
    b'33' : 'p010LEToUV_c',
    b'34' : 'p010BEToUV_c',
    b'35' : 'p016LEToUV_c',
    b'36' : 'p016BEToUV_c',
    b'37' : 'bgr24ToY_c',
    b'38' : 'bgr24ToUV_c',
    b'38_half' : 'bgr24ToUV_half_c',
    b'39' : 'rgb24ToY_c',
    b'40' : 'rgb24ToUV_c',
    b'40_half' : 'rgb24ToUV_half_c',
    b'41' : 'planar_rgb_to_y',
    b'42' : 'planar_rgb_to_a',
    b'43' : 'planar_rgb_to_uv',
    b'44' : 'planar_rgb16_to_y',
    b'45' : 'planar_rgb16_to_a',
    b'46' : 'planar_rgb16_to_uv',
    b'47' : 'grayf32ToY16_c',
    b'48' : 'grayf32ToY16_bswap_c'}


file1 = file2 = ''
with open('bench_cpu.txt','rb') as cpu:
    file1 = cpu.read()
    cpu.close()

with open('bench_vsx.txt','rb') as vsx:
    file2 = vsx.read()
    vsx.close()
    
res1 = re.findall(b'(\d+) UNITS in (\w+)', file1)
map1 = {}
for i in res1:
    if(i[1] not in map1.keys()):
        map1[i[1]] = (int(i[0]), 1)
    else:
        map1[i[1]] = (map1[i[1]][0] + int(i[0]), map1[i[1]][1]+1)
for i in map1.keys():
    map1[i] = int(map1[i][0]/map1[i][1])

res2 = re.findall(b'(\d+) UNITS in (\d+\w+)_vsx', file2)
map2 = {}
for i in res2:
    if(i[1] not in map2.keys()):
        map2[i[1]] = (int(i[0]), 1)
    else:
        map2[i[1]] = (map2[i[1]][0] + int(i[0]), map2[i[1]][1]+1)
for i in map2.keys():
    map2[i] = int(map2[i][0]/map2[i][1])

for i in map2.keys():
    print(funcs[i] + ': ' + str(map1[i]))
    print(funcs[i] + '_vsx: ' + str(map2[i]))
    print()
